package slgui.gfx;

/** A PainterContext holds a saved, internal state of a painter.
 * 
 * @author Zak Fenton
 *
 */
public class PainterContext {
	Painter painter;
	int stackIndex;
	
	/* The following should have equivalents in the Painter class. */
	Transformer transformer;

	public PainterContext() {
		reset();
	}
	
	public void reset() {
		painter = null;
		stackIndex = -1;
		
		transformer = null;
	}

	public void save(Painter p, int stackIndex) {
		this.painter = p;
		this.stackIndex = stackIndex;
		
		this.transformer = p.transformer;
	}
	
	public void restore(Painter p) {
		p.transformer = this.transformer;
	}
}
