package slgui.gfx;

/** A transformer represents an operation which applies to the coordinate space
 * (i.e. moving the x/y coordinates around in some pattern).
 * 
 * @author Zak Fenton
 *
 */
public class Transformer {
	/** This is the only non-subclass instance of Transformer which should be used, other than base classes. */
	public static Transformer DIRECT = new Transformer();

	protected Transformer() {
	}
	
	public double x(double x) {
		return x;
	}
	
	public double y(double y) {
		return y;
	}
	
	public double unX(double x) {
		return x;
	}
	
	public double unY(double y) {
		return y;
	}
	
	public double width(double w) {
		return w;
	}
	
	public double height(double h) {
		return h;
	}
	
	public double radius(double r) {
		return (width(r) + height(r)) / 2;
	}
	
	public Transformer over(Transformer other) {
		if (other == DIRECT) {
			return this;
		} else if (this == DIRECT) {
			return other;
		} else {
			return combinedTransformer(other);
		}
	}

	public Transformer combinedTransformer(Transformer other) {
		throw new Error("TODO!");
	}
}
