package slgui.space;

import slgui.base.MediaInputState;
import slgui.base.MediaModel;
import slgui.base.MediaPainter;
import slgui.base.MediaViewDelegate;

public class SpaceMediaModel extends MediaModel {
	SpaceState space;

	public SpaceMediaModel(SpaceState space) {
		this.space = space;
	}
	
	@Override
	protected void screenSizeChanged() {
		space.setCoordinates(0, 0, getWidth(), getHeight());
	}

	@Override
	public void paintView(MediaViewDelegate v, MediaPainter p) {
		space.paint(p);
	}
	
	@Override
	public void setInputState(MediaInputState input) {
		super.setInputState(input);
		space.setInputState(input);
	}
}
