package slgui.swing;

import java.awt.GraphicsConfiguration;
import java.awt.HeadlessException;

import javax.swing.JFrame;

import slgui.base.MediaModel;

public class GameWindow extends JFrame {
	GameComponent gameComponent;

	public GameWindow() throws HeadlessException {
		initUI();
	}

	public GameWindow(GraphicsConfiguration gc) {
		super(gc);
		initUI();
	}

	public GameWindow(String title) throws HeadlessException {
		super(title);
		initUI();
	}

	public GameWindow(String title, GraphicsConfiguration gc) {
		super(title, gc);
		initUI();
	}

	private void initUI() {
		gameComponent = new GameComponent();
		this.getContentPane().add(gameComponent);
		pack();
	}
	
	public void setModel(MediaModel m) {
		gameComponent.setModel(m);
	}
}
