package slgui.views;

import slgui.gfx.Painter;
import slgui.themes.Theme;

public abstract class View {
	private View outer;
	private View[] inners = null;
	
	public abstract void paint(Painter painter, Theme theme);
	
	public View outer() {
		return outer;
	}
	
	public View inner(int i) {
		return inners[i];
	}
	
	public int innerIndex(View v) {
		for (int i = 0; i < inners(); i++) {
			if (inner(i) == v) {
				return i;
			}
		}
		
		return -1;
	}
	
	public int inners() {
		return inners.length;
	}
	
	public void addView(View v) {
		View[] newInners = new View[inners() + 1];
		
		for (int i = 0; i < newInners.length; i++) {
			if (i < inners()) {
				newInners[i] = inner(i);
			} else {
				newInners[i] = v;
			}
		}
		
		inners = newInners;
	}
	
	public void removeView(View v) {
		int idx = innerIndex(v);
		if (idx >= 0) {
			View[] newInners = new View[inners() - 1];
			
			for (int i = 0; i < newInners.length; i++) {
				if (i < idx) {
					newInners[i] = inner(i);
				} else {
					newInners[i] = inner(i+1);
				}
			}
			
			inners = newInners;
		}
	}
}
